package com.jiuqi.util.tree;

import java.util.List;
import java.util.HashSet;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Iterator;

public abstract class FastTreeBuilder implements TreeBuilder
{
    protected ObjectVistor visitor;
    
    public FastTreeBuilder(final ObjectVistor visitor) {
        this.visitor = visitor;
    }
    
    public TreeNode build(final Iterator iterator) {
        final List allNodes = new ArrayList();
        final HashMap nodeFinder = new HashMap();
        while (iterator.hasNext()) {
            final Object item = iterator.next();
            final TreeNode node = new TreeNode(item);
            allNodes.add(node);
            nodeFinder.put(this.getObjectCode(item), node);
        }
        final TreeNode root = new TreeNode();
        final HashSet paths = new HashSet();
        for (int i = 0; i < allNodes.size(); ++i) {
            TreeNode node2 = allNodes.get(i);
            if (node2.getParent() == null) {
                paths.clear();
                while (true) {
                    paths.add(this.getObjectCode(node2.getItem()));
                    final TreeNode parent = nodeFinder.get(this.getObjectParent(node2.getItem()));
                    if (parent == null || paths.contains(this.getObjectCode(parent.getItem()))) {
                        break;
                    }
                    node2.setParent(parent);
                    node2 = parent;
                }
                node2 = allNodes.get(i);
                if (node2.getParent() == null) {
                    node2.setParent(root);
                }
            }
        }
        return root;
    }
    
    protected abstract String getObjectCode(final Object p0);
    
    protected abstract String getObjectParent(final Object p0);
}
